#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2dragon4search.py">
#<abstract4xi abstract = "shoots to direction dragon"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2dragon4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2dragon4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2dragon4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4dragon

global count2ack4dragon
global count2nack4dragon
global count2found4dragon
global count2short4dragon

global current2series4dragon
global candidate2series4dragon

global fileobject4dragon  

global keys2profile4dragon
global key2profile4dragon

global left2find4dragon

global maxsize2ack4dragon    
global maxsize2file4dragon 
global max2short4dragon
global meansize2ack4dragon
global minsize2ack4dragon

global dragon2analyse4search

global profile2fetch4dragon

global right2find4dragon

global sumsize2ack4dragon    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4dragon = VersionKB4Xi['base2shoot4dragon']             # base internet address, None=local url

count2ack4dragon   = 0
count2nack4dragon  = 0
count2found4dragon = 0
count2short4dragon = 0

left2find4dragon = '('

max2short4dragon = VersionKB4Xi['max2short4dragon']
maxsize2file4dragon = VersionKB4Xi['maxsize2file4dragon']
maxsize2ack4dragon  = 0
meansize2ack4dragon = 0
minsize2ack4dragon  = 0

current2series4dragon = "current2series4dragon5dummy"
candidate2series4dragon  = "candidate2series4dragon5dummy"


dragon2analyse4search  = VersionKB4Xi['dragon2analyse4search']

profile2fetch4dragon = {}
profile2fetch4dragon [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4dragon [2] = '.jpg'
keys2profile4dragon = profile2fetch4dragon.keys()

right2find4dragon = ')'

sumsize2ack4dragon  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4dragon" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4dragon(target2explore4dragon):
    global count2ack4dragon
    global count2nack4dragon
    global count2found4dragon
    global count2short4dragon
    
    global fileobject4dragon 
       
    global keys2profile4dragon
    global key2profile4dragon
    
    global left2find4dragon

    global max2short4dragon    
    global maxsize2file4dragon     
    global maxsize2ack4dragon    
    global meansize2ack4dragon
    global minsize2ack4dragon
  
    global candidate2series4dragon
    global current2series4dragon
    
    
    global profile2fetch4dragon                         # extension for files
    
    global right2find4dragon
    
    global sumsize2ack4dragon    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4dragon = count2found4dragon + 1
    ack2debug4dragon = False                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4dragon)
    
    ack2profile = False
    for key2profile4dragon in keys2profile4dragon:
        if name2target[1] == profile2fetch4dragon[key2profile4dragon]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2DRAGON4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4dragon
        if ack2debug4dragon is True:
            print("(STEP 0A/33) OF SHOOT2DRAGON4SEARCH - PATH2INPUT: ", path2input) 
            #  
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2DRAGON4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4dragon:
            count2nack4dragon = count2nack4dragon + 1
        else:
            count2ack4dragon = count2ack4dragon + 1
            sumsize2ack4dragon = sumsize2ack4dragon + size2file
            if size2file > maxsize2ack4dragon:
                maxsize2ack4dragon = size2file
            if ((size2file < minsize2ack4dragon) or (minsize2ack4dragon == 0)):
                print("(STEP 0B/33) OF SHOOT2DRAGON4SEARCH - USING MINSIZE2ACK4DRAGON: ", minsize2ack4dragon, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4DRAGON:  0  SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2dragon//d\dragonfly29july2012\dragonfly29july2012 (1).JPG 
                # USING MINSIZE2ACK4DRAGON:  3866624  SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2dragon//d\dragonfly29july2012\dragonfly29july2012 (2).JPG
                minsize2ack4dragon = size2file
                print("(STEP 0C/33) OF SHOOT2DRAGON4SEARCH - SET MINSIZE2ACK4DRAGON TO: ", minsize2ack4dragon, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4DRAGON TO:  3866624  = SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2dragon//d\dragonfly29july2012\dragonfly29july2012 (1).JPG
                # SET MINSIZE2ACK4DRAGON TO:  3538944  = SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2dragon//d\dragonfly29july2012\dragonfly29july2012 (2).JPG
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4dragon = target2explore4dragon
            if ack2debug4dragon is True:print("(STEP 1A/33) OF SHOOT2DRAGON4SEARCH - URL2WEB4DRAGON: ", url2web4dragon) 
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4dragon,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4dragon = url2web4dragon[0:index2edit] + string2use + url2web4dragon[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4dragon)
            shortname2web4dragon = name2web[0]
            if ack2debug4dragon is True:
                print("(STEP 1B/33) OF SHOOT2DRAGON4SEARCH - SHORTNAME2WEB4DRAGON: ", shortname2web4dragon)
                # 
            
            string2find4dragon = '/'
            ackall2found4dragon = False           
            while 1:
                if ackall2found4dragon is True:
                    break
                else:
                    index2find4dragon=str.find(shortname2web4dragon,string2find4dragon)   
                    if index2find4dragon == -1:
                        ackall2found4dragon = True
                    else:
                        shortname2web4dragon = shortname2web4dragon[index2find4dragon+1:]
                        
            if ack2debug4dragon is True:            
                print("(STEP 1C/33) OF SHOOT2DRAGON4SEARCH - SHORTNAME2WEB4DRAGON: ", shortname2web4dragon)
                # 
                
            ackall2found4dragon = False 
            while 1:
                if ackall2found4dragon is True:
                    break
                else:
                    index2left4dragon=str.find(shortname2web4dragon,left2find4dragon)
                    if index2left4dragon == -1:
                        current2series4dragon = shortname2web4dragon
                        if ack2debug4dragon is True:
                            print("(STEP 2A/33) OF SHOOT2DRAGON4SEARCH - CURRENT2SERIES4DRAGON: ", current2series4dragon) 
                            # 
                        ackall2found4dragon = True
                         
                    else:
                        index2right4dragon=str.find(shortname2web4dragon,right2find4dragon)
                        if index2right4dragon == -1:
                            ackall2found4dragon = True 
                        else:
                            candidate2series4dragon = shortname2web4dragon[0:index2left4dragon]
                            
                            index3find4dragon=str.find(shortname2web4dragon,current2series4dragon)
                            if index3find4dragon == -1:
                                
                                current2series4dragon = candidate2series4dragon
                                if ack2debug4dragon is True:
                                    print("(STEP 2B/33) OF SHOOT2DRAGON4SEARCH - CURRENT2SERIES4DRAGON: ", current2series4dragon) 
                                    # 
                                
                                count2short4dragon = 0
                                fileobject4dragon.write('<br />' + '\n')
                            else:
                                shortname2web4dragon = shortname2web4dragon[index2left4dragon:index2right4dragon+1]
                                if ack2debug4dragon is True:
                                    print("(STEP 2C/33) OF SHOOT2DRAGON4SEARCH - SHORTNAME2WEB4DRAGON: ", shortname2web4dragon)
                                    # 
                                
                                count2short4dragon = count2short4dragon + 1
                                if count2short4dragon >= max2short4dragon:
                                    count2short4dragon = 0
                                else:
                                    pass       
                            ackall2found4dragon = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4dragon is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4dragon.write('<br /><b>&raquo;</b><a href="' + url2web4dragon + '" target="_blank">' + shortname2web4dragon + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4dragon = dragon2analyse4search
                if ack2debug4dragon is True:
                    print("(STEP 3A/33) OF SHOOT2DRAGON4SEARCH - BASE2LOCAL4DRAGON: ", base2local4dragon)
                    #              
                ack2localtries4dragon = False                   
                while 1:
                    if ack2localtries4dragon is True:
                        break
                    else:
                        index2find4dragon=str.find(url2web4dragon,base2local4dragon)            
                        # 
                        #  
                        if index2find4dragon == -1:
                            ack2localtries4dragon = True
                        else:
                            if ack2debug4dragon is True:
                                print("(STEP 3B/33) OF SHOOT2DRAGON4SEARCH - BASE2BUILD4DRAGON: ", base2build4dragon)
                                # 
                            url2web4dragon = base2build4dragon + url2web4dragon[len(base2local4dragon):]
                            if ack2debug4dragon is True:
                                print("(STEP 3C/33) OF SHOOT2DRAGON4SEARCH - URL2WEB4DRAGON: ", url2web4dragon)
                                # 
                            
                            if count2short4dragon < 1: 
                                fileobject4dragon.write('<br /><b>&raquo;</b><a href="' + url2web4dragon + '" target="_blank">' + shortname2web4dragon + '</a>' + '\n')
                            else:
                                fileobject4dragon.write('<b>&raquo;</b><a href="' + url2web4dragon + '" target="_blank">' + shortname2web4dragon + '</a>\n')                            
                            ack2localtries4dragon = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2DRAGON4SEARCH FAILED, FILEOBJECT4DRAGON-WRITE-FAILED: ", str(fileobject4dragon), time4xi())
      
    else:
        
        count2nack4dragon = count2nack4dragon + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2dragon4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2dragon4search(queue2dragon = None, consumer_channel2dragon = None, publisher_channel2dragon = None, path2dragon = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4dragon
    global count2nack4dragon
    global count2found4dragon
    
    global fileobject4dragon    
    
    global maxsize2ack4dragon    
    global meansize2ack4dragon
    global minsize2ack4dragon
    global sumsize2ack4dragon    
    
    global maxsize2file4dragon 
    
    global profile2fetch4dragon                         # extension for files
    global keys2profile4dragon
    global key2profile4dragon

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2DRAGON4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2DRAGON4SEARCH -  QUEUE2DRAGON: ", queue2dragon)      
    # QUEUE2DRAGON:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2DRAGON4SEARCH -  CONSUMER_CHANNEL2DRAGON: ", consumer_channel2dragon)
    # CONSUMER_CHANNEL2DRAGON:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2DRAGON4SEARCH -  PUBLISHER_CHANNEL2DRAGON: ", publisher_channel2dragon)          
    # PUBLISHER_CHANNEL2DRAGON:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2dragon is None) or (consumer_channel2dragon is None) or (publisher_channel2dragon is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2DRAGON4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2DRAGON4SEARCH - QUEUE2DRAGON: ", queue2dragon)
        print("(STEP 1C/33) OF SHOOT2DRAGON4SEARCH - CONSUMER_CHANNEL2DRAGON: ", consumer_channel2dragon) 
        print("(STEP 1D/33) OF SHOOT2DRAGON4SEARCH - PUBLISHER_CHANNEL2DRAGON: ", publisher_channel2dragon)
        print("(STEP 1E/33) OF SHOOT2DRAGON4SEARCH - PATH2DRAGON: ", path2dragon)     
        
        return
 
    if (not (queue2dragon is None) and not(consumer_channel2dragon is None) and not(publisher_channel2dragon is None) and (path2dragon is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2DRAGON4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2DRAGON4SEARCH - QUEUE2DRAGON: ", queue2dragon)
        print("(STEP 2C/33) OF SHOOT2DRAGON4SEARCH - CONSUMER_CHANNEL2DRAGON: ", consumer_channel2dragon) 
        print("(STEP 2D/33) OF SHOOT2DRAGON4SEARCH - PUBLISHER_CHANNEL2DRAGON: ", publisher_channel2dragon)
        print("(STEP 2E/33) OF SHOOT2DRAGON4SEARCH - PATH2DRAGON: ", path2dragon)     
        return           

    if (not (queue2dragon is None) and not(consumer_channel2dragon is None) and not(publisher_channel2dragon is None) and not(path2dragon is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2DRAGON4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2DRAGON4SEARCH - QUEUE2DRAGON: ", queue2dragon)
        # QUEUE2DRAGON:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2DRAGON4SEARCH - CONSUMER_CHANNEL2DRAGON: ", consumer_channel2dragon)
        # CONSUMER_CHANNEL2DRAGON:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2DRAGON4SEARCH - PUBLISHER_CHANNEL2DRAGON: ", publisher_channel2dragon)
        # PUBLISHER_CHANNEL2DRAGON:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2DRAGON4SEARCH - PATH2DRAGON: ", path2dragon)
        # PATH2DRAGON:  F://temp//yophotos//test2dragon//
       
        print("(STEP 4A/33) OF SHOOT2DRAGON4SEARCH - STARTING TO WALK PATH2DRAGON: ", path2dragon)   
        # STARTING TO WALK PATH2DRAGON:  F://temp//yophotos//test2dragon//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4dragon = None
        try:
            name2index4dragon = "index2xxxxxxxx4yo.html"
            path2index4dragon = path2dragon + name2index4dragon
            print("(Step 4B/33) OF SHOOT2DRAGON4SEARCH - SET PATH2INDEX4DRAGON TO: ", path2index4dragon)
            # R://temp//yophotos//test//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4DRAGON: ", path2index4dragon)          
            #                    
        fileobject4dragon = None
        try:
            fileobject4dragon = open(path2index4dragon,'w')
            print("(Step 4C/33) OF SHOOT2DRAGON4SEARCH - OPENED OUTPUT: ", fileobject4dragon)
            # SHOOT2DRAGON4SEARCH - OPENED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2dragon//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 4Z2/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4dragon)         
            # 
        try:                
            fileobject4dragon.write('<html>\n')
            
            fileobject4dragon.write('<style type="text/css" media="all">\n')
            fileobject4dragon.write(' @import "https://www.yourdragonxi.org/css/halongbay.css";\n')
            fileobject4dragon.write('</style> \n')
            fileobject4dragon.write('<p>\n')
            fileobject4dragon.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4dragon.write('<br /><a id="000">yourdragon<b>&Xi;</b> @Content</a>\n')
            fileobject4dragon.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4dragon.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4dragon)         
            #      
        
        
        KB2name4dragon = {}
        key2name4dragon = 0
                 
        for file2walk in DirectoryWalker(path2dragon):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4dragon [key2name4dragon] = file2walk
                    print ("KB2NAME4DRAGON[", key2name4dragon, "]: ", KB2name4dragon [key2name4dragon])
                    # 
                    
                    key2name4dragon = key2name4dragon + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2DRAGON4SEARCH - FAILED UPDATING KB2NAME4DRAGON WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4dragon(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4dragon.write('<br /> \n')
            fileobject4dragon.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4dragon.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4dragon.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4dragon.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4dragon.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4dragon.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4dragon.write('</p>\n')
            # 
            fileobject4dragon.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4dragon)         
            #            
        try:    
            fileobject4dragon.close()
            print("(Step 4C/33) OF SHOOT2DRAGON4SEARCH - CLOSED OUTPUT: ", fileobject4dragon)         
            # SHOOT2DRAGON4SEARCH - CLOSED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2dragon//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>   
        except:
            print("(Step 4Z5/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4dragon)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2DRAGON4SEARCH - STARTING TO ANALYSE KB2NAME4DRAGON: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4DRAGON:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4dragon  = {}
        AlphaKB4dragon['a'] = {}
        AlphaKB4dragon['b'] = {}
        AlphaKB4dragon['c'] = {}
        AlphaKB4dragon['d'] = {}
        AlphaKB4dragon['e'] = {}
        AlphaKB4dragon['f'] = {}
        AlphaKB4dragon['g'] = {}
        AlphaKB4dragon['h'] = {}
        AlphaKB4dragon['i'] = {}
        AlphaKB4dragon['j'] = {}
        AlphaKB4dragon['k'] = {}
        AlphaKB4dragon['l'] = {}
        AlphaKB4dragon['m'] = {}
        AlphaKB4dragon['n'] = {}
        AlphaKB4dragon['o'] = {}
        AlphaKB4dragon['p'] = {}
        AlphaKB4dragon['q'] = {}
        AlphaKB4dragon['r'] = {}
        AlphaKB4dragon['s'] = {}
        AlphaKB4dragon['t'] = {}
        AlphaKB4dragon['u'] = {}
        AlphaKB4dragon['v'] = {}
        AlphaKB4dragon['w'] = {}
        AlphaKB4dragon['x'] = {}
        AlphaKB4dragon['y'] = {}
        AlphaKB4dragon['z'] = {} 
        keys2AlphaKB4dragon = AlphaKB4dragon.keys()
        key2AlphaKB4dragon  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4dragon = len(path2dragon)
        # 
        
        keys2name4dragon = KB2name4dragon.keys()
                
        for key2name4dragon in sorted(keys2name4dragon):
            # 
            name2optimize4dragon = KB2name4dragon[key2name4dragon]
            # 
            shortcut2level4dragon = name2optimize4dragon[len2cut4dragon:]
            # 
            len2shortcut4dragon = len(shortcut2level4dragon)
            if len2shortcut4dragon == 1:
                try:
                    # LEVEL DRAGON CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4dragon in keys2AlphaKB4dragon:
                        KB2level1[key2level1] = shortcut2level4dragon
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2DRAGON4SEARCH ** WARNING - SHORTCUT2LEVEL4DRAGON: ", shortcut2level4dragon, " NOT IN KEYS2ALPHAKB4DRAGON: ", keys2AlphaKB4dragon)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2DRAGON4SEARCH *** FAILED - SHORTCUT2LEVEL4DRAGON: ", shortcut2level4dragon)      
            else:
                try:
                    
                    string2search4dragon = '\\'
                    shortcut2level4dragon = shortcut2level4dragon[2:]
                    
                    index2level4dragon=str.find(shortcut2level4dragon,string2search4dragon)
                    if index2level4dragon == -1:
                         
                        KB2level2[key2level2] = shortcut2level4dragon
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4dragon = shortcut2level4dragon[index2level4dragon+1:]
                        index2level4dragon=str.find(shortcut2level4dragon,string2search4dragon)
                        if index2level4dragon == -1:
                            KB2level3[key2level3] = shortcut2level4dragon
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4dragon = shortcut2level4dragon[index2level4dragon+1:]
                            index2level4dragon=str.find(shortcut2level4dragon,string2search4dragon)
                            if index2level4dragon == -1:
                                KB2level4[key2level4] = shortcut2level4dragon
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4dragon = shortcut2level4dragon[index2level4dragon+1:]
                                index2level4dragon=str.find(shortcut2level4dragon,string2search4dragon)
                                if index2level4dragon == -1:
                                    KB2level5[key2level5] = shortcut2level4dragon
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4dragon = shortcut2level4dragon[index2level4dragon+1:]
                                    index2level4dragon=str.find(shortcut2level4dragon,string2search4dragon)
                                    if index2level4dragon == -1:
                                        KB2level6[key2level6] = shortcut2level4dragon
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4dragon = shortcut2level4dragon[index2level4dragon+1:]
                                        index2level4dragon=str.find(shortcut2level4dragon,string2search4dragon)
                                        if index2level4dragon == -1:
                                            KB2level7[key2level7] = shortcut2level4dragon
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4dragon = shortcut2level4dragon[index2level4dragon+1:]
                                            index2level4dragon=str.find(shortcut2level4dragon,string2search4dragon)
                                            if index2level4dragon == -1:
                                                KB2level8[key2level8] = shortcut2level4dragon
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2DRAGON4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4DRAGON: ", shortcut2level4dragon)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2DRAGON4SEARCH *** FAILED - SHORTCUT2LEVEL4DRAGON: ", shortcut2level4dragon)   
        
        print ("(Step 6A/33) OF SHOOT2DRAGON4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2DRAGON4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2DRAGON4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2DRAGON4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # dragonfly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2DRAGON4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2DRAGON4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2DRAGON4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2DRAGON4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2DRAGON4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2DRAGON4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2DRAGON4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2DRAGON4SEARCH - COUNT2ACK4DRAGON; ", count2ack4dragon)
            # COUNT2ACK4DRAGON;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2DRAGON4SEARCH - COUNT2NACK4DRAGON; ", count2nack4dragon)
            # COUNT2NACK4DRAGON;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2DRAGON4SEARCH - COUNT2FOUND4DRAGON: ", count2found4dragon)
            # COUNT2FOUND4DRAGON:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2DRAGON4SEARCH - FOUND MAX SIZE: ", maxsize2ack4dragon)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2DRAGON4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4dragon)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4dragon == 0:
                meansize2ack4dragon = 0
                print ("(Step 7G1/33) OF SHOOT2DRAGON4SEARCH - MEAN SIZE SET: ", meansize2ack4dragon)
                #  
            else:       
                meansize2ack4dragon = int(sumsize2ack4dragon / count2ack4dragon)
                print ("(Step 7G2/33) OF SHOOT2DRAGON4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4dragon, ", WHERE SUMSIZE2ACK4DRAGON: ", sumsize2ack4dragon, " COUNT2ACK4DRAGON: ", count2ack4dragon)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4DRAGON:  10944512  COUNT2ACK4DRAGON:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4dragon < maxsize2file4dragon:
                print ("(Step 7H/33) OF SHOOT2DRAGON4SEARCH - MIN SIZE MET: ", minsize2ack4dragon)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2DRAGON4SEARCH ** MIN DEFINED: ", minsize2ack4dragon, " EQUALS TO MAXSIZE2FILE4DRAGON: ", maxsize2file4dragon)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2DRAGON4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2DRAGON4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2DRAGON4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2DRAGON4SEARCH - QUEUE2DRAGON: ", queue2dragon)
        print("(STEP 7Z3/33) OF SHOOT2DRAGON4SEARCH - CONSUMER_CHANNEL2DRAGON: ", consumer_channel2dragon) 
        print("(STEP 7Z4/33) OF SHOOT2DRAGON4SEARCH - PUBLISHER_CHANNEL2DRAGON: ", publisher_channel2dragon)
        print("(STEP 7Z5/33) OF SHOOT2DRAGON4SEARCH - PATH2DRAGON: ", path2dragon)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2dragon4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
